/*
 * Copyright (C) 2014 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.launcher3.compat;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.LauncherActivityInfo;
import android.content.pm.LauncherApps;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.content.pm.ShortcutInfo;
import android.graphics.Rect;
import android.os.Bundle;
import android.os.Process;
import android.os.UserHandle;
import android.support.annotation.Nullable;
import android.util.Log;

import com.android.launcher3.compat.ShortcutConfigActivityInfo.ShortcutConfigActivityInfoVL;
import com.android.launcher3.shortcuts.ShortcutInfoCompat;
import com.android.launcher3.util.PackageUserKey;
import com.secspace.lib.common.utils.Prefs;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LauncherAppsCompatVL extends LauncherAppsCompat {

    protected final LauncherApps mLauncherApps;
    protected final Context mContext;

    private Map<OnAppsChangedCallbackCompat, WrappedCallback> mCallbacks = new HashMap<>();

    LauncherAppsCompatVL(Context context) {
        mContext = context;
        mLauncherApps = (LauncherApps) context.getSystemService(Context.LAUNCHER_APPS_SERVICE);
    }

    @Override
    public List<LauncherActivityInfo> getActivityList(String packageName, UserHandle user) {
        //wangx 只显示需要的应用，这里使用包名过滤一下，再返回. 可以参考下面内容
        List<LauncherActivityInfo> activityList = mLauncherApps.getActivityList(packageName, user);
        List<LauncherActivityInfo> newActivityList = new ArrayList<>();
        List<String> pkgsList = Prefs.getSystemShowAppPkgs(mContext);
        pkgsList.addAll(Prefs.getUserShowAppPkgs(mContext));

        for (int i = 0; i < activityList.size(); i++) {
            for (String pkg : pkgsList) {
                if (activityList.get(i).getApplicationInfo().packageName.equals(pkg)) {
                    newActivityList.add(activityList.get(i));
                }
            }
        }
        Log.i("LauncherAppsCompatVL", "packageName: " + packageName);
        Log.i("LauncherAppsCompatVL", "newActivityList size : " + newActivityList.size());
        return newActivityList;
//

//            List<LauncherActivityInfo> list = null;
//            UserHandle myUser = Process.myUserHandle();
//            Constructor constructor  = null;
//            try {
//                Class clazz = Class.forName("android.content.pm.LauncherActivityInfo");
//                Intent mainIntent = new Intent(Intent.ACTION_MAIN, null);
//                mainIntent.addCategory(CATEGORY_DEFAULT);
//                mainIntent.setPackage(packageName);
//                List<ResolveInfo> infos = mPm.queryIntentActivities(mainIntent, 0);
//                list = new ArrayList<>(infos.size());
//                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
//                    constructor = clazz.getDeclaredConstructor(Context.class, ActivityInfo.class, UserHandle.class);//c1.getDeclaredMethod("getInstance");
//                    constructor.setAccessible(true);
//                    for (ResolveInfo info : infos) {
//                        //mg add , don't load the activity in the application self.
//                        //Because it have load in xml.
//                        if(info.activityInfo.packageName.equals(mContext.getApplicationContext().getPackageName()))
//                            continue;
//                        list.add((LauncherActivityInfo)constructor.newInstance(mContext, info.activityInfo, myUser));
//                    }
//                } else {
//                    constructor = clazz.getDeclaredConstructor(Context.class, ResolveInfo.class, UserHandle.class, long.class);//c1.getDeclaredMethod("getInstance");
//                    constructor.setAccessible(true);
//                    for (ResolveInfo info : infos) {
//                        //mg add , don't load the activity in the application self.
//                        //Because it have load in xml.
//                        if(info.activityInfo.packageName.equals(mContext.getApplicationContext().getPackageName()))
//                            continue;
//                        list.add((LauncherActivityInfo)constructor.newInstance(mContext, info, myUser,0));
//                    }
//                }
//                return list;
//            } catch (ClassNotFoundException | NoSuchMethodException | IllegalAccessException | InstantiationException | InvocationTargetException e) {
//                e.printStackTrace();
//            }
//            return null;
    }


    @Override
    public LauncherActivityInfo resolveActivity(Intent intent, UserHandle user) {
        return mLauncherApps.resolveActivity(intent, user);
    }

    @Override
    public void startActivityForProfile(ComponentName component, UserHandle user,
                                        Rect sourceBounds, Bundle opts) {
        mLauncherApps.startMainActivity(component, user, sourceBounds, opts);
    }

    @Override
    public ApplicationInfo getApplicationInfo(String packageName, int flags, UserHandle user) {
        final boolean isPrimaryUser = Process.myUserHandle().equals(user);
        if (!isPrimaryUser && (flags == 0)) {
            // We are looking for an installed app on a secondary profile. Prior to O, the only
            // entry point for work profiles is through the LauncherActivity.
            List<LauncherActivityInfo> activityList =
                    mLauncherApps.getActivityList(packageName, user);
            return activityList.size() > 0 ? activityList.get(0).getApplicationInfo() : null;
        }
        try {
            ApplicationInfo info =
                    mContext.getPackageManager().getApplicationInfo(packageName, flags);
            // There is no way to check if the app is installed for managed profile. But for
            // primary profile, we can still have this check.
            if (isPrimaryUser && ((info.flags & ApplicationInfo.FLAG_INSTALLED) == 0)
                    || !info.enabled) {
                return null;
            }
            return info;
        } catch (PackageManager.NameNotFoundException e) {
            // Package not found
            return null;
        }


    }

    @Override
    public void showAppDetailsForProfile(ComponentName component, UserHandle user,
                                         Rect sourceBounds, Bundle opts) {
        mLauncherApps.startAppDetailsActivity(component, user, sourceBounds, opts);
    }

    @Override
    public void addOnAppsChangedCallback(LauncherAppsCompat.OnAppsChangedCallbackCompat callback) {
        WrappedCallback wrappedCallback = new WrappedCallback(callback);
        synchronized (mCallbacks) {
            mCallbacks.put(callback, wrappedCallback);
        }
        mLauncherApps.registerCallback(wrappedCallback);
    }

    @Override
    public void removeOnAppsChangedCallback(OnAppsChangedCallbackCompat callback) {
        final WrappedCallback wrappedCallback;
        synchronized (mCallbacks) {
            wrappedCallback = mCallbacks.remove(callback);
        }
        if (wrappedCallback != null) {
            mLauncherApps.unregisterCallback(wrappedCallback);
        }
    }

    @Override
    public boolean isPackageEnabledForProfile(String packageName, UserHandle user) {
        return mLauncherApps.isPackageEnabled(packageName, user);
    }

    @Override
    public boolean isActivityEnabledForProfile(ComponentName component, UserHandle user) {
        return mLauncherApps.isActivityEnabled(component, user);
    }

    private static class WrappedCallback extends LauncherApps.Callback {
        private LauncherAppsCompat.OnAppsChangedCallbackCompat mCallback;

        public WrappedCallback(LauncherAppsCompat.OnAppsChangedCallbackCompat callback) {
            mCallback = callback;
        }

        public void onPackageRemoved(String packageName, UserHandle user) {
            mCallback.onPackageRemoved(packageName, user);
        }

        public void onPackageAdded(String packageName, UserHandle user) {
            mCallback.onPackageAdded(packageName, user);
        }

        public void onPackageChanged(String packageName, UserHandle user) {
            mCallback.onPackageChanged(packageName, user);
        }

        public void onPackagesAvailable(String[] packageNames, UserHandle user, boolean replacing) {
            mCallback.onPackagesAvailable(packageNames, user, replacing);
        }

        public void onPackagesUnavailable(String[] packageNames, UserHandle user,
                                          boolean replacing) {
            mCallback.onPackagesUnavailable(packageNames, user, replacing);
        }


        public void onPackagesSuspended(String[] packageNames, UserHandle user) {
            mCallback.onPackagesSuspended(packageNames, user);
        }


        public void onPackagesUnsuspended(String[] packageNames, UserHandle user) {
            mCallback.onPackagesUnsuspended(packageNames, user);
        }

        public void onShortcutsChanged(String packageName, List<ShortcutInfo> shortcuts,
                                       UserHandle user) {
            List<ShortcutInfoCompat> shortcutInfoCompats = new ArrayList<>(shortcuts.size());
            for (ShortcutInfo shortcutInfo : shortcuts) {
                shortcutInfoCompats.add(new ShortcutInfoCompat(shortcutInfo));
            }

            mCallback.onShortcutsChanged(packageName, shortcutInfoCompats, user);
        }
    }

    @Override
    public List<ShortcutConfigActivityInfo> getCustomShortcutActivityList(
            @Nullable PackageUserKey packageUser) {
        List<ShortcutConfigActivityInfo> result = new ArrayList<>();
        if (packageUser != null && !packageUser.mUser.equals(Process.myUserHandle())) {
            return result;
        }
        PackageManager pm = mContext.getPackageManager();
        for (ResolveInfo info :
                pm.queryIntentActivities(new Intent(Intent.ACTION_CREATE_SHORTCUT), 0)) {
            if (packageUser == null || packageUser.mPackageName
                    .equals(info.activityInfo.packageName)) {
                result.add(new ShortcutConfigActivityInfoVL(info.activityInfo, pm));
            }
        }
        return result;
    }
}

